#ifndef FSGUICOMMONDRAWING_IS_INCLUDED
#define FSGUICOMMONDRAWING_IS_INCLUDED
/* { */

#include <ysclass.h>
#include <ysbitmap.h>
#include <ysbitmaparray.h>

class FsGuiCommonDrawing
{
public:
	static void DrawLine(double x1,double y1,double x2,double y2,const YsColor &col);
	static void DrawLineStrip(int n,const double plg[],const YsColor &col);
	static void DrawRect(double x1,double y1,double x2,double y2,const YsColor &col,YSBOOL fill);
	static void DrawCircle(double x,double y,double rad,const YsColor &col,YSBOOL fill);
	static void DrawPolygon(int n,const double plg[],const YsColor &col);
	static void DrawGradationPolygon(int n,const double plg[],const YsColor col[]);
	static void DrawBmp(const YsBitmap &bmp,double x,double y);
	static void DrawBmpArray(const YsBitmapArray &bmp,double x,double y);
	static void DrawMask(const YsColor &fgCol,const YsColor &bgCol,double x0,double y0,double wid,double hei);
	static void SetClipRect(double x0,double y0,double wid,double hei);
	static void ClearClipRect(void);
};

/* } */
#endif
