/* ////////////////////////////////////////////////////////////

  File Name: globalmenu.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "../fsgui3dapp.h"
#include "../textresource.h"

#include <ysshellextedit.h>

#include <ysshellextedit_localop.h>
#include <ysshellext_orientationutil.h>
#include <ysshellextedit_orientationutil.h>
#include <ysshellext_mappingutil.h>


/*static*/ void FsGui3DMainCanvas::Global_DeleteUnusedVertexAll(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	auto canvas=(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas->slHd)
	{
		YsShellExtEdit::StopIncUndo incUndo(canvas->slHd);
		/* for(auto vtHd=canvas->slHd->Vertex().begin(); canvas->slHd->Vertex().end()!=vtHd; ++vtHd)
		{
			if(YSTRUE!=canvas->slHd->IsVertexUsed(*vtHd))
			{
				canvas->slHd->DeleteVertex(*vtHd);
			}
		} */
		for(auto vtHd : canvas->slHd->AllVertex())
		{
			if(YSTRUE!=canvas->slHd->IsVertexUsed(vtHd))
			{
				canvas->slHd->DeleteVertex(vtHd);
			}
		}

		canvas->needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_VERTEX;
		canvas->SetNeedRedraw(YSTRUE);
	}
}

/*static*/ void FsGui3DMainCanvas::Global_InvertPolygonAll(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	auto canvas=(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas->slHd)
	{
		YsShellExtEdit::StopIncUndo stopIncUndo(canvas->slHd);

		YsArray <YsShellPolygonHandle> plHdArray;
		YsArray <YsVec3> newNomArray;
		for(auto plHd : canvas->slHd->AllPolygon())
		{
			YsArray <YsShellVertexHandle,4> plVtHd;
			canvas->slHd->GetPolygon(plVtHd,plHd);
			plVtHd.Invert();
			canvas->slHd->SetPolygonVertex(plHd,plVtHd);

			YsVec3 nom;
			canvas->slHd->GetNormal(nom,plHd);
			if(YsOrigin()!=nom)
			{
				nom=-nom;
				plHdArray.Append(plHd);
				newNomArray.Append(nom);
			}
		}

		canvas->slHd->SetPolygonNormalMulti(plHdArray,newNomArray);

		canvas->needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_POLYGON|NEED_REMAKE_DRAWING_SELECTED_POLYGON;
		canvas->SetNeedRedraw(YSTRUE);
	}
}

/*static*/ void FsGui3DMainCanvas::Global_SetZeroNormalAll(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	auto canvas=(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas->slHd)
	{
		YsArray <YsShellPolygonHandle> plHdArray;
		YsArray <YsVec3> newNomArray;
		for(auto plHd : canvas->slHd->AllPolygon())
		{
			plHdArray.Append(plHd);
			newNomArray.Append(YsOrigin());
		}

		canvas->slHd->SetPolygonNormalMulti(plHdArray,newNomArray);

		canvas->needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_POLYGON|NEED_REMAKE_DRAWING_SELECTED_POLYGON;
		canvas->SetNeedRedraw(YSTRUE);
	}
}

/*static*/ void FsGui3DMainCanvas::Global_FixOrientationAndNormalClosedVolume(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	auto canvas=(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas->slHd)
	{
		YsShellExtEdit::StopIncUndo stopIncUndo(canvas->slHd);
		YsShellExtEdit_OrientationUtil::FixOrientationOfClosedSolid(canvas->slHd->Conv());

		canvas->needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_POLYGON|NEED_REMAKE_DRAWING_SELECTED_POLYGON;
		canvas->SetNeedRedraw(YSTRUE);
	}
}

/*static*/ void FsGui3DMainCanvas::Global_TriangulateAll(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	YSRESULT res=YSOK;

	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	auto shlPtr=canvas.Slhd();
	if(NULL!=shlPtr)
	{
		auto &shl=*shlPtr;
		auto selPlHd=shl.GetSelectedPolygon();

		YsShellExtEdit::StopIncUndo incUndo(canvas.Slhd());

		for(auto plHd : shl.AllPolygon())
		{
			YsArray <YsShellVertexHandle,4> plVtHd;
			shl.GetPolygon(plVtHd,plHd);
			if(3<plVtHd.GetN())
			{
				if(YSOK!=YsShellExtEdit_TriangulatePolygon(shl,plHd))
				{
					res=YSERR;
				}
			}
		}
	}

	canvas.needRemakeDrawingBuffer=(unsigned int)NEED_REMAKE_DRAWING_POLYGON|NEED_REMAKE_DRAWING_SELECTED_POLYGON;
	canvas.SetNeedRedraw(YSTRUE);

	if(YSOK!=res)
	{
		canvas.MessageDialog(FSGUI_COMMON_ERROR,FSGUI_ERROR_TRIANGULATIONERROR);
	}
}

/* static */ void FsGui3DMainCanvas::Global_DeleteRedundantVertex(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	canvas.numberDlg->Make(FSGUI_COMMON_DISTTHR,FSGUI_COMMON_OK,FSGUI_COMMON_CANCEL);
	canvas.numberDlg->SetCloseModalCallBack(Global_DeleteRedundantVertex_ToleranceEntered);
	canvas.numberDlg->SetRealNumber(YsTolerance);
	canvas.AttachModalDialog(canvas.numberDlg);
}

/* static */ void FsGui3DMainCanvas::Global_DeleteRedundantVertex_ToleranceEntered(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK!=(YSRESULT)returnValue)
	{
		return;
	}

	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	const double tol=canvas.numberDlg->GetRealNumber();

	canvas.Global_DeleteRedundantVertex(tol,NULL);
}



/* static */ void FsGui3DMainCanvas::Global_DeleteRedundantVertexNonManifoldEdgeOnly(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	canvas.numberDlg->Make(FSGUI_COMMON_DISTTHR,FSGUI_COMMON_OK,FSGUI_COMMON_CANCEL);
	canvas.numberDlg->SetCloseModalCallBack(Global_DeleteRedundantVertexNonManifoldEdgeOnly_ToleranceEntered);
	canvas.numberDlg->SetRealNumber(YsTolerance);
	canvas.AttachModalDialog(canvas.numberDlg);
}



/* static */ void FsGui3DMainCanvas::Global_DeleteRedundantVertexNonManifoldEdgeOnly_ToleranceEntered(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
	if(YSOK!=(YSRESULT)returnValue)
	{
		return;
	}

	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	auto shlPtr=canvas.Slhd();
	if(NULL!=shlPtr)
	{
		auto &shl=*shlPtr;

		const double tol=canvas.numberDlg->GetRealNumber();

		YsShellVertexStore limitedVtx(shl.Conv());
		for(auto vtHd : shl.AllVertex())
		{
			auto connVtHd=shl.GetConnectedVertex(vtHd);
			for(auto vtHd2 : connVtHd)
			{
				if(2>shl.GetNumPolygonUsingEdge(vtHd,vtHd2))
				{
					limitedVtx.AddVertex(vtHd);
					break;
				}
			}
		}

		canvas.Global_DeleteRedundantVertex(tol,&limitedVtx);
	}
}



void FsGui3DMainCanvas::Global_DeleteRedundantVertex(const double tol,const YsShellVertexStore *limitedVtx)
{
	auto shlPtr=Slhd();
	if(NULL!=shlPtr)
	{
		auto &shl=*shlPtr;

		YsShellExtEdit::StopIncUndo incUndo(Slhd());


		YsShellExt_VertexToVertexMapping vtxMap;
		YsShellExt_MakeVertexMappingWithTolerance(vtxMap,shl.Conv(),tol,limitedVtx);


		for(auto plHd : shl.AllPolygon())
		{
			auto plVtHd=shl.GetPolygonVertex(plHd);
			YSBOOL change=YSFALSE;
			for(auto &vtHd : plVtHd)
			{
				YsArray <YsShellVertexHandle> mapped;
				vtxMap.FindMapping(mapped,shl.Conv(),vtHd);
				if(vtHd!=mapped[0])
				{
					vtHd=mapped[0];
					change=YSTRUE;
				}
			}
			if(YSTRUE==change)
			{
				for(YSSIZE_T idx=plVtHd.GetN()-1; 0<=idx; --idx)
				{
					if(plVtHd[idx]==plVtHd.GetCyclic(idx+1))
					{
						plVtHd.Delete(idx);
					}
				}
				if(3<=plVtHd.GetN())
				{
					shl.SetPolygonVertex(plHd,plVtHd);
				}
				else
				{
					shl.DeletePolygon(plHd);
				}
			}
		}

		for(auto ceHd : shl.AllConstEdge())
		{
			YSBOOL isLoop;
			YsArray <YsShellVertexHandle> ceVtHd;
			shl.GetConstEdge(ceVtHd,isLoop,ceHd);

			YSBOOL change=YSFALSE;
			for(auto &vtHd : ceVtHd)
			{
				YsArray <YsShellVertexHandle> mapped;
				vtxMap.FindMapping(mapped,shl.Conv(),vtHd);
				if(vtHd!=mapped[0])
				{
					vtHd=mapped[0];
					change=YSTRUE;
				}
			}
			if(YSTRUE==change)
			{
				if(YSTRUE==isLoop)
				{
					for(YSSIZE_T idx=ceVtHd.GetN()-1; 0<=idx; --idx)
					{
						if(ceVtHd[idx]==ceVtHd.GetCyclic(idx+1))
						{
							ceVtHd.Delete(idx);
						}
					}
				}
				else
				{
					for(YSSIZE_T idx=ceVtHd.GetN()-2; 0<=idx; --idx)
					{
						if(ceVtHd[idx]==ceVtHd[idx+1])
						{
							ceVtHd.Delete(idx);
						}
					}
				}

				if(3<=ceVtHd.GetN())
				{
					shl.ModifyConstEdge(ceHd,ceVtHd,isLoop);
				}
				if(2<=ceVtHd.GetN())
				{
					shl.ModifyConstEdge(ceHd,ceVtHd,YSFALSE);
				}
				else
				{
					shl.DeleteConstEdge(ceHd);
				}
			}
		}

		needRemakeDrawingBuffer=(unsigned int)
		    NEED_REMAKE_DRAWING_POLYGON|NEED_REMAKE_DRAWING_SELECTED_POLYGON|
		    NEED_REMAKE_DRAWING_CONSTEDGE|NEED_REMAKE_DRAWING_SELECTED_CONSTEDGE;
		SetNeedRedraw(YSTRUE);
	}
}
