/* ////////////////////////////////////////////////////////////

  File Name: miscdlg.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef MISCDLG_IS_INCLUDED
#define MISCDLG_IS_INCLUDED
/* { */

#include <fsgui.h>

class YsColorPaletteDialog : public FsGuiDialog
{
private:
	YsColorPaletteDialog();
	~YsColorPaletteDialog();

public:
	FsGuiColorPalette *plt;
	FsGuiButton *savePlt,*loadPlt;

	class FsGui3DMainCanvas *canvas;
	class FsGuiFileDialog *fdlg;
	FsGuiMessageBoxDialog yesno;

	static YsColorPaletteDialog *Create(void);
	static void Delete(YsColorPaletteDialog *dlg);

	void MakeDialog(class FsGui3DMainCanvas *ownerIn);
	void InitDialog(void);

	void SetColor(const YsColor &col);
	YsColor GetColor(void) const;

	virtual void OnButtonClick(FsGuiButton *btn);

	YsWString savePaletteFileName;
	void SavePalette(const wchar_t fn[]) const;
	void LoadPalette(const wchar_t fn[]);
    virtual void OnModalDialogClosed(int dialogIdent,class FsGuiDialog *closedModalDialog,int modalDialogEndCode);
};

/* } */
#endif
