/* ////////////////////////////////////////////////////////////

  File Name: refbmp.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef REFBMP_IS_INCLUDED
#define REFBMP_IS_INCLUDED
/* { */

#include <ysclass.h>
#include <ysbitmap.h>

class PolyCreReferenceBitmap
{
public:
	YsWString fn;
	YSBOOL loaded;
	YsBitmap bmp;
	YsBitmap scaled;

	int scaleWid,scaleHei,paddedWid,paddedHei;

	YsVec3 corner[4];
	YSBOOL show,alignCenter;
	double alpha;
	mutable YSBOOL textureNamePrepared;
	mutable YSBOOL textureCached;
	mutable unsigned int textureName;

	PolyCreReferenceBitmap();
	~PolyCreReferenceBitmap();
	void Initialize(void);
	YSRESULT Load(const char fn[]);
	void CalculateScalingAndPadding(void);
	void ApplyScalingAndPadding(void);
	void MakeTransparency(void);

	void MakeTentativeCorner(void);
	void MakeXY(void);
	void MakeXZ(void);
	void MakeYZ(void);

	void Draw(void) const;
	void DrawHighlight(void) const;
private:
	void CacheTexture(void) const;
};

class PolyCreReferenceBitmapStore
{
public:
	enum 
	{
		MAX_NUM_REFBMP=16
	};
	PolyCreReferenceBitmap refBmp[MAX_NUM_REFBMP];

private:
	PolyCreReferenceBitmapStore();
	~PolyCreReferenceBitmapStore();

public:
	static PolyCreReferenceBitmapStore *Create(void);
	static void Delete(PolyCreReferenceBitmapStore *ptr);

	void Initialize(void);
	YSRESULT Load(const wchar_t fn[]);
	YSRESULT Save(const wchar_t fn[]) const;

	void Draw(void) const;
	void DrawHighlight(int bmpIdx) const;
};

/* } */
#endif
