/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_duplicateutil.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef YSSHELLEXTEDIT_DUPLICATEUTIL_IS_INCLUDED
#define YSSHELLEXTEDIT_DUPLICATEUTIL_IS_INCLUDED
/* { */

#include "ysshellext_duplicateutil.h"

class YsShellExtEdit_DuplicateUtil : public YsShellExt_DuplicateUtil
{
public:
	/*! Make a copy of entities stored in this class. */
	YSRESULT Paste(class YsShellExtEdit &dstShl);

	/*! Make a copy of a mirror-image of the entities stored in dupUtil.
	    The flag dontMakeCopyOnSymmPlane can be YSTRUE only when a copy is made within the same shell. */
	YSRESULT MakeAxisymmetric(class YsShellExtEdit &shl,const int component,YSBOOL dontMakeCopyOnSymmPlane,YSBOOL deletePolygonOnSymmPlane);

	/*! Make a copy of a mirror-image of the entities stored in dupUtil.
	    The flag dontMakeCopyOnSymmPlane can be YSTRUE only when a copy is made within the same shell. */
	YSRESULT MakeBySymmetryPlane(class YsShellExtEdit &shl,const YsPlane &pln,YSBOOL dontMakeCopyOnSymmPlane,YSBOOL deletePolygonOnSymmPlane);

private:
	void PasteConstEdge(class YsShellExtEdit &dstShl);
	void PasteConstEdgeForMirrorImage(class YsShellExtEdit &shl);
	void PasteFaceGroup(class YsShellExtEdit &dstShl);
};



/* } */
#endif
