/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_orientationutil.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "ysshellextedit_orientationutil.h"

YsShellExtEdit_OrientationUtil::YsShellExtEdit_OrientationUtil()
{
}

YsShellExtEdit_OrientationUtil::~YsShellExtEdit_OrientationUtil()
{
}

YSRESULT YsShellExtEdit_OrientationUtil::RecalculateNormal(YsShellExtEdit &shl,YsShellPolygonHandle plHd)
{
	YsArray <YsVec3,4> plVtPos;
	shl.GetPolygon(plVtPos,plHd);

	YsVec3 nom;
	if(YSOK==YsGetAverageNormalVector(nom,plVtPos))
	{
		shl.SetPolygonNormal(plHd,nom);
		return YSOK;
	}
	return YSERR;
}

/*static*/ void YsShellExtEdit_OrientationUtil::FixOrientationOfClosedSolid(YsShellExtEdit &shl)
{
	YsShellExt_OrientationUtil orientationUtil;
	orientationUtil.CleanUp();
	orientationUtil.FixOrientationOfClosedSolid(shl.Conv());
	auto plHdNeedFip=orientationUtil.GetPolygonNeedFlip();

	for(auto plHd : plHdNeedFip)
	{
		YsArray <YsShellVertexHandle,4> plVtHd;
		shl.GetPolygon(plVtHd,plHd);
		plVtHd.Invert();
		shl.SetPolygonVertex(plHd,plVtHd);
	}

	orientationUtil.RecalculateNormalFromCurrentOrientation(shl.Conv());
	auto plNomPairNeedNormalReset=orientationUtil.GetPolygonNormalPair();
	for(auto plNomPair : plNomPairNeedNormalReset)
	{
		shl.SetPolygonNormal(plNomPair.plHd,plNomPair.nom);
	}
}

