uniform int billBoardClippingType;
uniform int billBoardTransformType;
uniform sampler2D textureIdent;

varying "YS_GLSL_HIGHP" vec2 texCoordOut;
varying "YS_GLSL_LOWP" vec4 color;

#include "YS_GLSL_FOG_VARIABLES.glsl"
#include "YS_GLSL_ALPHA_CUTOFF_PARAMETER.glsl"

void main()
{
	if(YSGLSL_BILLBOARD_CLIPPING_CIRCLE==billBoardClippingType)
	{
		"YS_GLSL_MIDP" vec2 nomLocal=(texCoordOut.xy*2.0)-vec2(1.0,1.0);
		if(1.0<=dot(nomLocal,nomLocal))
		{
			discard;
		}
	}

	"YS_GLSL_LOWP" vec4 texcell=texture2D(textureIdent,texCoordOut);
	gl_FragColor=color*texcell;

	#include "YS_GLSL_ALPHA_CUTOFF_IN_FRAGMENT_SHADER.glsl"
	#include "YS_GLSL_FOGCALCULATION_IN_FRAGMENTSHADER.glsl"
}
